
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2015 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title LSR (immediate)

@encoding(t1) {

    @half 0 0 0 0 1 imm5(5) Rm(3) Rd(3)

    @syntax <Rgd> <Rgm> <shift>

    @conv {

        Rgd = Register(Rd)
        Rgm = Register(Rm)
        shift = DecodeImmShift(1, imm5)

    }

    @rules {

        if (imm5 == '00000') ; see MOV (register, Thumb)
        //if (imm5 == '00000') ; see MOV (register)

    }

}

@encoding(T2) {

    @word 1 1 1 0 1 0 1 0 0 1 0 S(1) 1 1 1 1 0 imm3(3) Rd(4) imm2(2) 0 1 Rm(4)

    @syntax {s} <Rgd> <Rgm> <shift>

    @conv {

        S = SetFlags(S)
        Rgd = Register(Rd)
        Rgm = Register(Rm)
        shift = DecodeImmShift(1, imm3:imm2)

    }

    @rules {

        if ((imm3 == '000') && (imm2 == '00')) ; see MOV (register, Thumb)
        //if ((imm3 == '000') && (imm2 == '00')) ; see MOV (register, Thumb)
        //if (imm3:imm2) == '00000' then SEE MOV (register);
        //if d IN {13,15} || m IN {13,15} then UNPREDICTABLE;

    }

}

@encoding(A1) {

    @word cond(4) 0 0 0 1 1 0 1 S(1) 0 0 0 0 Rd(4) imm5(5) 0 1 0 Rm(4)

    @syntax {S} {c} <Rgd> <Rgm> <shift>

    @conv {

        S = SetFlags(S)
        c = Condition(cond)
        Rgd = Register(Rd)
        Rgm = Register(Rm)
        shift = DecodeImmShift(1, imm5)

    }

    @rules {

        //if Rd == '1111' && S == '1' then SEE SUBS PC, LR and related instructions;
        //if imm5 == '00000' then SEE MOV (register);

    }

}
