
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title PUSH

@encoding(t1) {

    @half 1 0 1 1 0 1 0 M(1) register_list(8)

    @syntax <registers>

    @conv {

        registers = RegistersList('0':M:'000000':register_list)

    }

    @rules {

        //if BitCount(registers) < 1 then UNPREDICTABLE;

        if (M == '1'); call SetInsFlag(AIF_ROUTINE_START);

    }

}

@encoding(T2) {

    @word 1 1 1 0 1 0 0 1 0 0 1 0 1 1 0 1 0 M(1) 0 register_list(13)

    @syntax "push.W" <registers>

    @conv {

        registers = RegistersList('0':M:'0':register_list)

    }

    @rules {

        //if BitCount(registers) < 2 then UNPREDICTABLE;

        if (M == '1'); call SetInsFlag(AIF_ROUTINE_START);

    }

}

@encoding(T3) {

    @word 1 1 1 1 1 0 0 0 0 1 0 0 1 1 0 1 Rt(4) 1 1 0 1 0 0 0 0 0 1 0 0

    @syntax "push.W" <registers>

    @conv {

        Rgt = Register(Rt)
        registers = ListFromRegister(Rgt)

    }

    @rules {

        //if t IN {13,15} then UNPREDICTABLE

        if (Rt == '1110'); call SetInsFlag(AIF_ROUTINE_START);

    }

}

@encoding(A1) {

    @word cond(4) 1 0 0 1 0 0 1 0 1 1 0 1 register_list(16)

    @syntax {c} <registers>

    @conv {

        c = Condition(cond)
        registers = RegistersList(register_list)

    }

    @rules {

        //if BitCount(register_list) < 2 then SEE STMDB / STMFD;

        if (register_list & 0x4000); call SetInsFlag(AIF_ROUTINE_START);

    }

}

@encoding(A2) {

    @word cond(4) 0 1 0 1 0 0 1 0 1 1 0 1 Rt(4) 0 0 0 0 0 0 0 0 0 1 0 0

    @syntax {c} <registers>

    @conv {

        c = Condition(cond)
        Rgt = Register(Rt)
        registers = ListFromRegister(Rgt)

    }

    @rules {

        //if t == 13 then UNPREDICTABLE;

        if (Rt == '1110'); call SetInsFlag(AIF_ROUTINE_START);

    }

}
